%define anolis_release 1
Name:      elinks
Summary:   A text-mode Web browser
Version:   0.16.1.1
Release:   %{anolis_release}%{?dist}
License:   GPLv2
URL:       https://github.com/rkd77/elinks
Source:    https://github.com/rkd77/elinks/releases/download/v%{version}/elinks-%{version}.tar.xz
Source2:   elinks.conf

BuildRequires: autoconf
BuildRequires: automake
BuildRequires: libtool
BuildRequires: bzip2-devel
BuildRequires: libzstd-devel
BuildRequires: xz-devel
BuildRequires: expat-devel
BuildRequires: gcc-c++
BuildRequires: gettext
BuildRequires: gpm-devel
BuildRequires: krb5-devel
BuildRequires: libidn2-devel
BuildRequires: lua-devel
BuildRequires: make
BuildRequires: openssl-devel
BuildRequires: zlib-devel
BuildRequires: pkgconfig(libbrotlidec)
Requires(preun): %{_sbindir}/alternatives
Requires(post): coreutils
Requires(post): %{_sbindir}/alternatives
Requires(postun): coreutils
Requires(postun): %{_sbindir}/alternatives
Provides: webclient
Provides: links = 1:0.97-1
Provides: text-www-browser

# Prevent crash when HOME is unset (bug #90663).
Patch0: 0000-elinks-0.15.0-ssl-noegd.patch

# UTF-8 by default
Patch1: 0001-elinks-0.15.1-utf_8_io-default.patch

# Make getaddrinfo call use AI_ADDRCONFIG.
Patch3: elinks-0.11.0-getaddrinfo.patch

# Don't put so much information in the user-agent header string (bug #97273).
Patch4: 0004-elinks-0.15.0-sysname.patch

# Fix xterm terminal: "Linux" driver seems better than "VT100" (#128105)
Patch5: 0005-elinks-0.15.0-xterm.patch

# add support for GNU Libidn2, patch by Robert Scheck (#1098789)
Patch6: 0006-elinks-0.16.0-libidn2.patch

# let list_is_singleton() return false for an empty list (#1075415)
Patch15: elinks-0.12pre6-list_is_singleton.patch

%description
Elinks is a text-based Web browser. Elinks does not display any images,
but it does support frames, tables and most other HTML tags. Elinks'
advantage over graphical browsers is its speed--Elinks starts and exits
quickly and swiftly displays Web pages.

%prep
%autosetup -p1

# remove bogus serial numbers
sed -e 's/^# *serial [AM0-9]*$//' -i config/m4/*.m4

%build
# recreate autotools files
autoreconf -fi
export CFLAGS="$RPM_OPT_FLAGS $(getconf LFS_CFLAGS) -D_GNU_SOURCE"

# make the code build with lua-5.4.x
CFLAGS="$CFLAGS -DLUA_COMPAT_5_3"

%configure %{?rescue:--without-gpm} \
    --enable-88-colors              \
    --enable-256-colors             \
    --enable-true-color             \
    --enable-bittorrent             \
    --with-gssapi                   \
    --with-luapkg=lua               \
    --with-openssl                  \
    --without-gnutls                \
    --with-zstd                     \
    --with-brotli                   \
    --with-lzma                     \
    --enable-gettext                \
    --without-spidermonkey          \
    --without-x

make

%install
%make_install
install -D -p -m 644 %{SOURCE2} $RPM_BUILD_ROOT%{_sysconfdir}/elinks.conf
touch $RPM_BUILD_ROOT%{_bindir}/links
touch $RPM_BUILD_ROOT%{_mandir}/man1/links.1%{_extension}
%find_lang elinks

%postun
if [ "$1" -ge "1" ]; then
	links=`readlink %{_sysconfdir}/alternatives/links`
	if [ "$links" == "%{_bindir}/elinks" ]; then
		%{_sbindir}/alternatives --set links %{_bindir}/elinks
	fi
fi
exit 0

%post
#Set up alternatives files for links
%{_sbindir}/alternatives --install %{_bindir}/links links %{_bindir}/elinks 90 \
  --slave %{_mandir}/man1/links.1%{_extension} links.1%{_extension} %{_mandir}/man1/elinks.1%{_extension}
links=`readlink %{_sysconfdir}/alternatives/links`
if [ "$links" == "%{_bindir}/elinks" ]; then
	%{_sbindir}/alternatives --set links %{_bindir}/elinks
fi


%preun
if [ $1 = 0 ]; then
	%{_sbindir}/alternatives --remove links %{_bindir}/elinks
fi
exit 0

%files -f elinks.lang
%license COPYING
%ghost %verify(not md5 size mtime) %{_bindir}/links
%{_bindir}/elinks
%ghost %verify(not md5 size mtime) %{_mandir}/man1/links.1%{_extension}
%config(noreplace) %{_sysconfdir}/elinks.conf
%{_mandir}/man1/elinks.1*
%{_mandir}/man5/*

%changelog
* Wed May 03 2023 Funda Wang <fundawang@yeah.net> - 0.16.1.1-1
- New version 0.16.1.1

* Sat Jan 21 2023 Funda Wang <fundawang@yeah.net> - 0.16.0-1
- Import package for anolis 23
